<?php
/**
 * The template for displaying Archive pages
 */

get_header(); ?>

<div class="row">
	<div id="archive-page" class="col-sm-12 col-md-6 col-md-push-3 entry-content">

		<?php if ( have_posts() ) : ?>

			<?php
				// Breadcrumbs
				aa_breadcrumbs();
			?>

			<a name="contenuto"></a>

			<h1 class="page-title">
				<?php
					if ( is_day() ):
						printf( 'Articoli del %s', get_the_date() );
					elseif ( is_month() ):
						printf( 'Articoli di %s', get_the_date( 'F Y' ) );
					elseif ( is_year() ):
						printf( 'Articoli del %s', get_the_date( 'Y' ) );
					elseif ( is_author() ):
						$author = get_userdata( get_query_var('author') );
						echo 'Articoli di ' . $author->display_name;
					elseif ( is_category() ):
						printf( 'Articoli in "%s"', single_cat_title( '', false ) );
					elseif ( is_tag() ):
						printf( 'Articoli con tag "%s"', single_tag_title( '', false ) );
					elseif ( is_tax() ):
						printf( 'Articoli in "%s"', single_term_title('', false) );
					else :
						echo 'Archivio';
					endif;
				?>
			</h1>

			<?php
				if(is_category() || is_tax()) {
					// Show an optional term description.
					$term_description = term_description();
					if ( ! empty( $term_description ) )
						printf( '<div class="taxonomy-description">%s</div>', $term_description );
				}
			?>

			<?php
				// Start the Loop.
				while ( have_posts() ) : the_post();

					/*
					 * Include the post format-specific template for the content. If you want to
					 * use this in a child theme, then include a file called called content-___.php
					 * (where ___ is the post format) and that will be used instead.
					 */
					get_template_part( 'content', get_post_format() );

				endwhile;
				// Previous/next page navigation.
				get_template_part('pagination');

				else :
					// If no content, include the "No posts found" template.
					get_template_part( 'content', 'none' );

				endif;
		?>
	</div>

	<?php get_sidebar(); ?>

</div>

<?php get_footer(); ?>
