<?php
/**
 * The default template for displaying content
 * Used for index/archive/search.
 */
?>

<div id="post-<?php the_ID(); ?>" <?php post_class('listed-post'); ?>>

	<?php if(is_sticky()): ?>
		<span class="featured-label label label-default"><?php _ex('In evidenza', 'etichetta "in evidenza" su articolo', 'amm-accessibile'); ?></span>
	<?php endif; ?>

	<p class="meta header">
		<?php // .post-date ?>
		<?php echo get_the_time(get_option('date_format')); ?>
		<?php comments_number( '', ' – 1 commento', ' – % commenti' ); ?> 
	</p>

	<h1 class="home-post-heading">
		<a href="<?php the_permalink(); ?>" rel="bookmark" title="Link permanente a <?php the_title_attribute(); ?>">
			<?php the_title(); ?>
		</a>
	</h1>
	
	<?php if(!$post->post_excerpt): ?>
		<div class="post-content"><?php the_content(''); ?></div>
		<a href="<?php the_permalink(); ?>" title="Link permanente a <?php the_title_attribute(); ?>">
			<button type="button" class="more btn btn-primary">Leggi tutto...</button>
		</a>


	<?php else: ?>
		<?php if ( has_post_thumbnail()) : ?> 	
			<a class="crop" href="<?php the_permalink(); ?>" title="Link permanente a <?php the_title_attribute(); ?>">
				<?php the_post_thumbnail('large', array('class' => 'media-object')); ?>
			</a>
		<?php endif; ?>
		<div class="post-content"><?php the_excerpt(); ?></div>
		<a href="<?php the_permalink(); ?>" title="Link permanente a <?php the_title_attribute(); ?>">
			<button type="button" class="more btn btn-primary">Leggi tutto...</button>
		</a>
	<?php endif; ?>
	
	<div class="meta meta-footer">
		<?php printf('Pubblicato il %s da %s in %s', get_the_time(get_option('date_format')), return_the_author_posts_link(), return_the_category()); ?>
	</div>

</div>	
<hr class="sr-only" />	