<?php

add_action( 'template_redirect', 'aa_avcp_tpl', 9 );

function aa_avcp_tpl () {
	remove_action( 'template_redirect', 'avcp_job_cpt_template' );
	if(get_post_type()=='avcp') {
		if(have_posts())
			add_filter('the_content', 'aa_avcp_tpl_filter');
		else
			$GLOBALS['wp_query']->is_404 = true;
	}
}

function aa_avcp_tpl_filter ( $content ) {

	$mesi = array(1=>'gennaio', 'febbraio', 'marzo', 'aprile', 'maggio', 'giugno', 'luglio', 'agosto', 'settembre', 'ottobre', 'novembre','dicembre');
	$postID                    = get_the_ID();
	list($giorno,$mese,$anno)  = explode(' ',date('j n Y',strtotime(get_post_meta($postID, 'avcp_data_inizio', true))));
	$avcp_data_inizio          = "$giorno {$mesi[$mese]} $anno";
	list($giorno,$mese,$anno)  = explode(' ',date('j n Y',strtotime(get_post_meta($postID, 'avcp_data_fine', true))));
	$avcp_data_fine            = "$giorno {$mesi[$mese]} $anno";
	$cig                       = get_post_meta($postID, 'avcp_cig', true);
	$ente                      = get_option('avcp_denominazione_ente');
	$areesettori               = AA_AVCP_Tpl::areesettori($postID);
	$cf                        = get_option('avcp_codicefiscale_ente');
	$oggetto                   = get_the_title($postID);
	$contraente                = get_post_meta($postID, 'avcp_contraente', true);
	$aggiudicazione            = get_post_meta($postID, 'avcp_aggiudicazione', true);
	$somme                     = get_post_meta($postID, 'avcp_somme_liquidate', true);
	$get_avcp_dis_archivioanni = get_option('avcp_dis_archivioanni');
	$annirif                   = $get_avcp_dis_archivioanni=='1' ? strip_tags(get_the_term_list( $postID, 'annirif', '', ' - ', '' )) : get_the_term_list( $postID, 'annirif', '', ' - ', '' );
	$partecipanti              = AA_AVCP_Tpl::partecipanti($postID);
	$aggiudicari               = AA_AVCP_Tpl::aggiudicari($postID);

	return <<<out

	<dl class="dl-horizontal">
		<dt> <acronym title="Codice Identificativo Gara">CIG</acronym>: </dt>
		<dd> {$cig} </dd>
		<dt> Struttura proponente: </dt>
		<dd> {$ente} {$areesettori} <br> {$cf} </dd>
		<dt> Oggetto del bando: </dt>
		<dd> {$oggetto} </dd>
		<dt> Procedura di scelta del contraente: </dt>
		<dd> {$contraente} </dd>
		<dt> Importo di aggiudicazione: </dt>
		<dd> {$aggiudicazione} </dd>
		<dt> Data di effettivo inizio: </dt>
		<dd> {$avcp_data_inizio} </dd>
		<dt> Data di ultimazione: </dt>
		<dd> {$avcp_data_fine} </dd>
		<dt> Importo delle somme liquidate: </dt>
		<dd> {$somme} </dd>
		<dt> Anno di riferimento: </dt>
		<dd> {$annirif} </dd>
	</dl>

	<h3>Elenco degli operatori partecipanti</h3>

	<dl class="dl-horizontal">
		{$partecipanti}
	</dl>

	<h3>Elenco degli operatori aggiudicari</h3>

	<dl class="dl-horizontal">
		{$aggiudicari}
	</dl>

out;
}

class AA_AVCP_Tpl {

	static function areesettori ( $postID ) {
		if($terms = get_the_terms( $postID, 'areesettori' ))
			foreach($terms as $term) {
				$get_term       = get_term_by('name', $term->name, 'areesettori');
				$id_sec_red_var = get_tax_meta($get_term->term_id,'aree_settori_cc_url');
				$id_sec_cc_var  = get_tax_meta($get_term->term_id,'aree_settori_cc_responsabile');
				$url            = get_permalink($id_sec_red_var);
				$out            = " - <a href='$url'> $term->name </a>";
				if (!($id_sec_cc_var == ''))
					$out .= ' - [<acronym title="Responsabile del Centro di Costo">resp. <b>' . $id_sec_cc_var . '</b></acronym>]';
				return $out;
			}
	}

	static function partecipanti ( $postID ) {
		$out = '';
		if ($terms = get_the_terms( $postID, 'ditte' ))
			foreach($terms as $term) {
				$get_term    = get_term_by('name', $term->name, 'ditte');
				$t_id        = $get_term->term_id;
				$term_meta   = get_option( "taxonomy_$t_id" );
				$term_return = esc_attr( $term_meta['avcp_codice_fiscale'] );
				$stato_var   = get_tax_meta($t_id,'avcp_is_ditta_estera');
				$is_estera   = empty($stato_var) ? '<acronym title="Identificativo Fiscale Italiano">IT</acronym>' : '<acronym title="Identificativo Fiscale Estero">EE</acronym>';
				$dt = get_option('avcp_dis_archivioditte') == '1' ? $term->name : '<a href="' . get_term_link( $t_id, 'ditte' ) . '" title="' . $term->name . '">' . $term->name . '</a>';
				$out .= "
					<dt> {$dt} </dt>
					<dd> {$term_return} <strong>{$is_estera}</strong> </dd>
				";
			}
		return $out;
	}

	static function aggiudicari ( $postID ) {
		$out = '';
		$dittepartecipanti = get_the_terms( $postID, 'ditte' );
		$cats              = get_post_meta($postID, 'avcp_aggiudicatari', true);
		if(is_array($dittepartecipanti))
			foreach ($dittepartecipanti as $term) {
				$cterm       = get_term_by('name', $term->name, 'ditte');
				$cat_id      = $cterm->term_id; //Prende l'id del termine
				$term_meta   = get_option( "taxonomy_$cat_id" );
				$term_return = esc_attr( $term_meta['avcp_codice_fiscale'] );
				$checked     = (in_array($cat_id,(array)$cats) ? ' checked="checked"': '');
				$stato_var   = get_tax_meta($cat_id, 'avcp_is_ditta_estera');
				$is_estera   = empty($stato_var) ? '<acronym title="Identificativo Fiscale Italiano">IT</acronym>' : '<acronym title="Identificativo Fiscale Estero">EE</acronym>';
				if ($checked) {
					$dt = get_option('avcp_dis_archivioditte') == '1' ? $term->name : '<a href="' . get_term_link( $cterm->term_id, 'ditte' ) . '" title="' . $term->name . '">' . $term->name . '</a>';
					$out .= "
						<dt> {$dt} </dt>
						<dd> {$term_return} <strong>{$is_estera}</strong> </dd>
					";
				}
			}
		return $out;
	}

}