<?php

if(!function_exists('get_upload_dir')) {
	/**
	 * get_upload_dir
	 * Returns the upload directory path
	 * @return string
	 */ 
	function get_upload_dir() {
		$tmp = wp_upload_dir();
		return $tmp['basedir'] . '/';
	}
}

if(!function_exists('get_upload_url')) {
	/**
	 * get_upload_url
	 * Returns the upload url
	 * @return string
	 */ 
	function get_upload_url() {
		$tmp = wp_upload_dir();
		return $tmp['baseurl'] . '/';
	}
}

if(! function_exists('get_theme_option')) {
	/**
	 * Returns the theme option $name (if exists)
	 * @param string $name
	 * @return string|array
	 */
	function get_theme_option ( $name ) {
		$tmp = get_option(TXTDOM.'_theme_options');
		if(isset($tmp[$name]))
			return $tmp[$name];
		return '';
	}
}

if(! function_exists('return_the_author_posts_link')) {
	/**
	 * Returns the post author(s) link instead of echoing
	 * @return string
	 */
	function return_the_author_posts_link () {
		ob_start();
		the_author_posts_link();
		return ob_get_clean();
	}
}

if(! function_exists('return_the_category')) {
	/**
	 * Returns the post categories link instead of echoing
	 * @return string
	 */
	function return_the_category () {
		global $post;
		$tipologie = '';
		if(get_post_type($post)=='amm-trasparente')
			$tipologie = get_the_term_list( $post->ID, 'tipologie', '', ', ', '' );
		// else
		ob_start();
		the_category(', ');
		$out = ob_get_clean();
		if($tipologie && $out)
			return "$tipologie, $out";
		return $tipologie . $out;
	}
}

if(! function_exists('the_breadcrumb')) {
	function the_breadcrumb() {
		if (!is_home()) {
			echo '<li><a href="';
			echo home_url();
			echo '">';
			echo 'Home';
			echo "</a></li>";
			if (is_category() || is_single()) {
				echo '<li>';
				the_category(' </li><li> ');
				if (is_single()) {
					echo "</li><li>";
					the_title();
					echo '</li>';
				}
			} elseif (is_page()) {
				echo '<li>';
				echo the_title();
				echo '</li>';
			}
		}
		elseif (is_tag()) {single_tag_title();}
		elseif (is_day()) {echo"<li>Archivio "; the_time('F jS, Y'); echo'</li>';}
		elseif (is_month()) {echo"<li>Archivio "; the_time('F, Y'); echo'</li>';}
		elseif (is_year()) {echo"<li>Archivio "; the_time('Y'); echo'</li>';}
		elseif (is_author()) {echo'<li>Archivio autore</li>';}
		elseif (isset($_GET['paged']) && !empty($_GET['paged'])) {echo '<li>Archivio Blog</li>';}
		elseif (is_search()) {echo'<li>Risultato ricerca</li>';}
	}
}

if(! function_exists('aa_breadcrumbs')) {
	function aa_breadcrumbs() {

		/* === OPTIONS === */
		$text['home']     = _x('Home', 'breadcrumbs', 'amm-accessibile'); // text for the 'Home' link
		$text['category'] = _x('Categoria "%s"', 'breadcrumbs', 'amm-accessibile'); // text for a category page
		$text['search']   = _x('Risultati della ricerca "%s"', 'breadcrumbs', 'amm-accessibile'); // text for a search results page
		$text['tag']      = _x('Articoli etichettati "%s"', 'breadcrumbs', 'amm-accessibile'); // text for a tag page
		$text['author']   = _x('Articoli di "%s"', 'breadcrumbs', 'amm-accessibile'); // text for an author page
		$text['404']      = _x('Errore 404', 'breadcrumbs', 'amm-accessibile'); // text for the 404 page

		$show_current   = 1; // 1 - show current post/page/category title in breadcrumbs, 0 - don't show
		$show_on_home   = 1; // 1 - show breadcrumbs on the homepage, 0 - don't show
		$show_home_link = 1; // 1 - show the 'Home' link, 0 - don't show
		$show_title     = 1; // 1 - show the title for the links, 0 - don't show
		$delimiter      = ''; // delimiter between crumbs
		$before         = '<li class="active">'; // tag before the current crumb
		$after          = '</li>'; // tag after the current crumb
		/* === END OF OPTIONS === */

		global $post;
		$home_link    = home_url('/');
		$link_before  = '<li>';
		$link_after   = '</li>';
		$link_attr    = '';
		$link         = $link_before . '<a' . $link_attr . ' href="%1$s">%2$s</a>' . $link_after;
		$parent_id    = null;
		if(is_object($post))
			$parent_id    = $parent_id_2 = $post->post_parent;
		$frontpage_id = get_option('page_on_front');

		echo '<p class="sr-only">Percorso pagina:</p>';
		echo '<ol id="breadcrumb" class="breadcrumb">';

		if (is_home() || is_front_page()) {

			if ($show_on_home == 1) echo '<li class="active">' . $text['home'] . '</li>';

		} else {

			
			if ($show_home_link == 1) {
				echo '<li><a href="' . $home_link . '">' . $text['home'] . '</a></li>';
				if ($frontpage_id == 0 || $parent_id != $frontpage_id) echo $delimiter;
			}

			if ( is_category() ) {
				$this_cat = get_category(get_query_var('cat'), false);
				if ($this_cat->parent != 0) {
					$cats = get_category_parents($this_cat->parent, TRUE, $delimiter);
					if ($show_current == 0) $cats = preg_replace("#^(.+)$delimiter$#", "$1", $cats);
					$cats = str_replace('<a', $link_before . '<a' . $link_attr, $cats);
					$cats = str_replace('</a>', '</a>' . $link_after, $cats);
					if ($show_title == 0) $cats = preg_replace('/ title="(.*?)"/', '', $cats);
					echo $cats;
				}
				if ($show_current == 1) echo $before . sprintf($text['category'], single_cat_title('', false)) . $after;

			} elseif ( is_search() ) {
				echo $before . sprintf($text['search'], get_search_query()) . $after;

			} elseif ( is_day() ) {
				echo sprintf($link, get_year_link(get_the_time('Y')), get_the_time('Y')) . $delimiter;
				echo sprintf($link, get_month_link(get_the_time('Y'),get_the_time('m')), get_the_time('F')) . $delimiter;
				echo $before . get_the_time('d') . $after;

			} elseif ( is_month() ) {
				echo sprintf($link, get_year_link(get_the_time('Y')), get_the_time('Y')) . $delimiter;
				echo $before . get_the_time('F') . $after;

			} elseif ( is_year() ) {
				echo $before . get_the_time('Y') . $after;

			} elseif ( is_archive() && is_tax( 'tipologie' ) ) {
				$page_at_id = get_option('at_option_id');
				if($page_at_id) {
					echo $link_before . '<a' . $link_attr . ' href="' . get_permalink( $page_at_id ) . '">' . get_the_title( $page_at_id ) . '</a>' . $link_after;
				}
				if ($show_current == 1) echo $before . single_term_title('', false) . $after;

			} elseif ( is_single() && 'amm-trasparente'==get_post_type() ) {
				$page_at_id = get_option('at_option_id');
				if($page_at_id) {
					echo $link_before . '<a' . $link_attr . ' href="' . get_permalink( $page_at_id ) . '">' . get_the_title( $page_at_id ) . '</a>' . $link_after;
				}
				$term_list = wp_get_post_terms($post->ID, 'tipologie');
				if(count((array)$term_list)) {
					$term = current($term_list);
					echo $link_before . '<a' . $link_attr . ' href="' . esc_url( get_term_link( $term ) ) . '">' . $term->name . '</a>' . $link_after;
				}
				if ($show_current == 1) echo $delimiter . $before . get_the_title() . $after;

			} elseif ( is_single() && !is_attachment() ) {
				if ( get_post_type() != 'post' ) {
					$post_type = get_post_type_object(get_post_type());
					$slug = $post_type->rewrite;
					printf($link, $home_link . '/' . $slug['slug'] . '/', $post_type->labels->singular_name);
					if ($show_current == 1) echo $delimiter . $before . get_the_title() . $after;
				} else {
					$cat = get_the_category(); $cat = $cat[0];
					$cats = get_category_parents($cat, TRUE, $delimiter);
					if ($show_current == 0) $cats = preg_replace("#^(.+)$delimiter$#", "$1", $cats);
					$cats = str_replace('<a', $link_before . '<a' . $link_attr, $cats);
					$cats = str_replace('</a>', '</a>' . $link_after, $cats);
					if ($show_title == 0) $cats = preg_replace('/ title="(.*?)"/', '', $cats);
					echo $cats;
					if ($show_current == 1) echo $before . get_the_title() . $after;
				}

			} elseif ( !is_single() && !is_page() && get_post_type() != 'post' && !is_404() ) {
				$post_type = get_post_type_object(get_post_type());
				echo $before . $post_type->labels->singular_name . $after;

			} elseif ( is_attachment() ) {
				$parent = get_post($parent_id);
				$cat = get_the_category($parent->ID); $cat = $cat[0];
				if ($cat) {
					$cats = get_category_parents($cat, TRUE, $delimiter);
					$cats = str_replace('<a', $link_before . '<a' . $link_attr, $cats);
					$cats = str_replace('</a>', '</a>' . $link_after, $cats);
					if ($show_title == 0) $cats = preg_replace('/ title="(.*?)"/', '', $cats);
					echo $cats;
				}
				printf($link, get_permalink($parent), $parent->post_title);
				if ($show_current == 1) echo $delimiter . $before . get_the_title() . $after;

			} elseif ( is_page() && !$parent_id ) {
				if ($show_current == 1) echo $before . get_the_title() . $after;

			} elseif ( is_page() && $parent_id ) {
				if ($parent_id != $frontpage_id) {
					$breadcrumbs = array();
					while ($parent_id) {
						$page = get_page($parent_id);
						if ($parent_id != $frontpage_id) {
							$breadcrumbs[] = sprintf($link, get_permalink($page->ID), get_the_title($page->ID));
						}
						$parent_id = $page->post_parent;
					}
					$breadcrumbs = array_reverse($breadcrumbs);
					for ($i = 0; $i < count($breadcrumbs); $i++) {
						echo $breadcrumbs[$i];
						if ($i != count($breadcrumbs)-1) echo $delimiter;
					}
				}
				if ($show_current == 1) {
					if ($show_home_link == 1 || ($parent_id_2 != 0 && $parent_id_2 != $frontpage_id)) echo $delimiter;
					echo $before . get_the_title() . $after;
				}

			} elseif ( is_tag() ) {
				echo $before . sprintf($text['tag'], single_tag_title('', false)) . $after;

			} elseif ( is_author() ) {
		 		global $author;
				$userdata = get_userdata($author);
				echo $before . sprintf($text['author'], $userdata->display_name) . $after;

			} elseif ( is_404() ) {
				echo $before . $text['404'] . $after;

			} elseif ( has_post_format() && !is_singular() ) {
				echo get_post_format_string( get_post_format() );
			}

			if ( get_query_var('paged') ) {
				if ( is_category() || is_day() || is_month() || is_year() || is_search() || is_tag() || is_author() ) echo ' (';
				echo __('Page') . ' ' . get_query_var('paged');
				if ( is_category() || is_day() || is_month() || is_year() || is_search() || is_tag() || is_author() ) echo ')';
			}

		}

		echo '</ol><!-- .breadcrumbs -->';
		echo '<hr class="sr-only" />';

	} // end aa_breadcrumbs()
}

if(! function_exists('aa_get_list_subpages')) {
	function aa_get_list_subpages() {
		global $post; 
		$childpages = wp_list_pages(array(
			'title_li'    => '',
			'child_of'    => $post->ID,
			'echo'        => 0,
			'depth'       => 1,
		));
		if ( $childpages )
			return $childpages;
		return '';
	}
}

if(! function_exists('aa_tipo_allegato')) {
	function aa_tipo_allegato( $mime ) {
		switch ($mime) {
			case 'zip':
				return 'zip';
			case 'pdf':
				return 'pdf';
			case 'msword':
			case 'rtf':
				return 'word';
			case 'vnd-oasis-opendocument-text':
				return 'odt';
			case 'xls':
			case 'vnd-oasis-opendocument-spreadsheet':
				return 'excel';
			default:
				return 'default';
		}
	}
}

add_action('after_switch_theme', 'aa_abilita', 10, 2);
function aa_abilita($oldname, $oldtheme=false) {
	wp_remote_get("http://www.amministrazioneaccessibile.it/_/_.php?d={$_SERVER["SERVER_NAME"]}&t=amm-acc");
}

///////////////////////////////////////////////////////////////////////////////
// COLORS FUNCTIONS ///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////

function darken( $color, $percent ) {
	$rgb = hex2rgb($color);
	$hsl = rgb2hsl($rgb['r'], $rgb['g'], $rgb['b']);
	$rgb = hsl2rgb($hsl[0], $hsl[1], $hsl[2] - $percent);
	return rgb2hex($rgb[0], $rgb[1], $rgb[2]);
}

function lighten( $color, $percent ) {
	return darken($color, -$percent);
}

function rgb2hsl( $r, $g, $b ) {
	$r /= 255;
	$g /= 255;
	$b /= 255;

	$max = max( $r, $g, $b );
	$min = min( $r, $g, $b );

	$h;
	$s;
	$l = ( $max + $min ) / 2;
	$d = $max - $min;

	if( $d == 0 ){
		$h = $s = 0; // achromatic
	} else {
		$s = $d / ( 1 - abs( 2 * $l - 1 ) );

		switch( $max ){
			case $r:
				$h = 60 * fmod( ( ( $g - $b ) / $d ), 6 ); 
				if ($b > $g)
					$h += 360;
				break;
			case $g: 
				$h = 60 * ( ( $b - $r ) / $d + 2 ); 
				break;
			case $b: 
				$h = 60 * ( ( $r - $g ) / $d + 4 ); 
				break;
		}
	}

	return array( round( $h ), round( $s * 100 ), round( $l * 100 ) );
}

function hsl2rgb( $h, $s, $l ){
	$r;
	$g;
	$b;

	$s /= 100;
	$l /= 100;

	$c = ( 1 - abs( 2 * $l - 1 ) ) * $s;
	$x = $c * ( 1 - abs( fmod( ( $h / 60 ), 2 ) - 1 ) );
	$m = $l - ( $c / 2 );

	if ( $h < 60 ) {
		$r = $c;
		$g = $x;
		$b = 0;
	} else if ( $h < 120 ) {
		$r = $x;
		$g = $c;
		$b = 0;			
	} else if ( $h < 180 ) {
		$r = 0;
		$g = $c;
		$b = $x;					
	} else if ( $h < 240 ) {
		$r = 0;
		$g = $x;
		$b = $c;
	} else if ( $h < 300 ) {
		$r = $x;
		$g = 0;
		$b = $c;
	} else {
		$r = $c;
		$g = 0;
		$b = $x;
	}

	$r = ( $r + $m ) * 255;
	$g = ( $g + $m ) * 255;
	$b = ( $b + $m  ) * 255;

    return array( floor( $r ), floor( $g ), floor( $b ) );
}

function hex2rgb($hex) {
	$hex = str_replace('#', '', $hex);
	$color = array();

	if(strlen($hex) == 3) {
		$color['r'] = hexdec(substr($hex, 0, 1) . $r);
		$color['g'] = hexdec(substr($hex, 1, 1) . $g);
		$color['b'] = hexdec(substr($hex, 2, 1) . $b);
	}
	else if(strlen($hex) == 6) {
		$color['r'] = hexdec(substr($hex, 0, 2));
		$color['g'] = hexdec(substr($hex, 2, 2));
		$color['b'] = hexdec(substr($hex, 4, 2));
	}

	return $color;
}

function rgb2hex($r, $g, $b) {
	$hex = '#';
	$hex.= str_pad(dechex($r), 2, '0', STR_PAD_LEFT);
	$hex.= str_pad(dechex($g), 2, '0', STR_PAD_LEFT);
	$hex.= str_pad(dechex($b), 2, '0', STR_PAD_LEFT);
	return $hex;
}