<?php

class AA_Context {

	private	$id   = NULL;	
	public	$menu = array();

	function __construct ( $id_pagina ) {
		$this->id = $id_pagina;
		$storia   = $this->storia();
		$pointer  =& $this->menu;
		foreach ($storia as $id) {
			$pointer[$id] = $this->figli($id);
			$pointer      =& $pointer[$id];
		}
	}

	// ritorna un array con tutti gli ID degli antenati della pagina (compresa)
	function storia () {
		$storia = array_reverse(get_post_ancestors($this->id));
		array_push($storia, $this->id);
		return $storia;
	}

	function figli ( $id_pagina ) {
		$figli = get_pages("child_of={$id_pagina}&hierarchical=0&parent={$id_pagina}&sort_column=menu_order");
		if(count($figli)){
			$IDs = array();
			foreach ($figli as $f)
				$IDs[$f->ID] = NULL;
			return $IDs;
		}
		return NULL;
	}

	// funzione ricorsiva che costruisce l'html del menù
	function html ( $array, $classe = 'children' ) {
		$return = "<ul class='{$classe}'>";
		foreach ($array as $k => $v) {
			$active_page = $k == $this->id ? 'current_page_item' : '';
			$url         = get_page_link($k);
			$title       = get_the_title($k);
			$return     .= "<li class='page_item page-item-{$k} {$active_page} list-group-item'><a href='{$url}'>{$title}</a>";
			if(is_array($v))
				$return .= $this->html($v);
			$return     .= '</li>';
		}
		$return .= '</ul>';
		return $return;
	}

	// restituisce true se la pagina ha un menu contestuale
	function ha_menu_contestuale () {
		return is_array(current($this->menu));
	}

}