<?php

class AA_Amm_Digitale_Box_Widget extends WP_Widget {

	function __construct() {
		parent::__construct(
	 		'AA_amm_digitale_box_widget', // Base ID
			'AA > Amm. Digitale Box', // Name
			array( 'description' => 'Amministrazione Digitale Box | Amministrazione Accessibile' ) // Args
		);
	}

	function widget( $args, $instance ) {
		extract($args);
		$title = apply_filters( 'widget_title', empty( $instance['title'] ) ? '' : $instance['title'], $instance, $this->id_base );
		$testodefault = "Tutte le informazioni concernenti l'organizzazione e le attività dell'Ente secondo le norme in materia di obblighi di pubblicità, trasparenza e diffusione di informazioni da parte delle PA (D.Lgs 14.03.2013 n.33).";
		$text = apply_filters( 'widget_text', empty( $instance['text'] ) ? $testodefault : $instance['text'], $instance );
		$im = empty($instance['im']) ? get_template_directory_uri().'/im/bandiera-italiana.jpg' : $instance['im'];
		$pag = empty($instance['pag']) ? '' : $instance['pag'];
		echo $before_widget;
		if ( empty( $title ) )
			$title = 'Amministrazione Trasparente';
		echo $before_title . $title . $after_title; ?>
			<div class="amm-trasparente-widget panel-body">
				<p class="amm-trasparente-im">
					<img src="<?php echo $im; ?>" alt="immagine amministrazione trasparente" />
				</p>
				<p class="amm-trasparente-testo">
					<?php echo $text; ?>
				</p>
				<?php if($pag): ?>
					<a class="amm-trasparente-btn btn btn-primary" href="<?php echo $pag; ?>">Entra</a>
				<?php endif; ?>
			</div>
		<?php
		echo $after_widget;
	}

	function update( $new_instance, $old_instance ) {
		$instance = $old_instance;
		$instance['title'] = strip_tags($new_instance['title']);
		$instance['text'] = stripslashes( wp_filter_post_kses( addslashes($new_instance['text']) ) ); // wp_filter_post_kses() expects slashed
		$instance['im'] = esc_url($new_instance['im']);
		$instance['pag'] = esc_url($new_instance['pag']);
		return $instance;
	}

	function form( $instance ) {
		$instance = wp_parse_args( (array) $instance, array( 'title' => '', 'text' => '', 'im' => '', 'pag' => '' ) );
		$title = strip_tags($instance['title']);
		$text = esc_textarea($instance['text']);
		$im = esc_url($instance['im']);
		$pag = esc_url($instance['pag']);
?>
		<p><label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('Title:'); ?></label>
		<input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo esc_attr($title); ?>" /></p>

		<p><label for="<?php echo $this->get_field_id('im'); ?>">URL immagine:</label>
		<input class="widefat" id="<?php echo $this->get_field_id('im'); ?>" name="<?php echo $this->get_field_name('im'); ?>" type="text" value="<?php echo $im; ?>" /></p>

		<p><label for="<?php echo $this->get_field_id('text'); ?>">Testo:</label>
		<textarea class="widefat" rows="10" cols="20" id="<?php echo $this->get_field_id('text'); ?>" name="<?php echo $this->get_field_name('text'); ?>"><?php echo $text; ?></textarea>

		<p>Lasciare i campi precedenti vuoti per utilizzare quelli predefiniti.</p>

		<p><label for="<?php echo $this->get_field_id('pag'); ?>">URL pagina:</label>
		<input class="widefat" id="<?php echo $this->get_field_id('pag'); ?>" name="<?php echo $this->get_field_name('pag'); ?>" type="text" value="<?php echo $pag; ?>" /></p>
<?php
	}
}