<?php

class AA_Amm_Digitale_Menu_Widget extends WP_Widget {

	function __construct() {
		parent::__construct(
	 		'aa_amm_digitale_widget', // Base ID
			'AA > Amministrazione Digitale Menù', // Name
			array( 'description' => 'Amministrazione Digitale Menù | Amministrazione Accessibile' ) // Args
		);
	}

	function widget( $args, $instance ) {
		extract($args);
		$title = apply_filters( 'widget_title', empty( $instance['title'] ) ? '' : $instance['title'], $instance, $this->id_base );
		$im = empty($instance['im']) ? get_template_directory_uri().'/im/bandiera-italiana.jpg' : $instance['im'];
		// Get menu
		$nav_menu = ! empty( $instance['nav_menu'] ) ? wp_get_nav_menu_object( $instance['nav_menu'] ) : false;

		echo $before_widget;
		
		if ( empty( $title ) )
			$title = 'Amministrazione Digitale';
		
		echo $before_title . $title . $after_title;
		?>

		<div class="amm-digitale-widget panel-body">
			<img class="amm-digitale-im" src="<?php echo $im; ?>" alt="immagine amministrazione digitale" />
		</div>

		<?php
		$menu = wp_nav_menu( array(
			'fallback_cb' => '',
			'menu' => $nav_menu,
			'container' => '',
			'menu_class' => 'list-group',
			'depth' => 1,
			'echo' => 0
		) );
		echo preg_replace('/([^\w-])menu-item([^\w-])/i', '$1list-group-item menu-item$2', $menu);
		
		echo $after_widget;
	}

	function update( $new_instance, $old_instance ) {
		$instance = $old_instance;
		$instance['title'] = strip_tags($new_instance['title']);
		$instance['im'] = esc_url($new_instance['im']);
		$instance['nav_menu'] = (int) $new_instance['nav_menu'];
		return $instance;
	}

	function form( $instance ) {
		$instance = wp_parse_args( (array) $instance, array( 'title' => '', 'im' => '', 'menu' => '' ) );
		$title = strip_tags($instance['title']);
		$im = esc_url($instance['im']);
		// Get menus
		$menus = wp_get_nav_menus( array( 'orderby' => 'name' ) );
?>
		<p><label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('Title:'); ?></label>
		<input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo esc_attr($title); ?>" /></p>

		<p><label for="<?php echo $this->get_field_id('im'); ?>">URL immagine:</label>
		<input class="widefat" id="<?php echo $this->get_field_id('im'); ?>" name="<?php echo $this->get_field_name('im'); ?>" type="text" value="<?php echo $im; ?>" /></p>

		<p>Lasciare i campi precedenti vuoti per utilizzare quelli predefiniti.</p>

		<p>
			<label for="<?php echo $this->get_field_id('nav_menu'); ?>"><?php _e('Select Menu:'); ?></label>
			<select id="<?php echo $this->get_field_id('nav_menu'); ?>" name="<?php echo $this->get_field_name('nav_menu'); ?>">
		<?php
			foreach ( $menus as $menu ) {
				echo '<option value="' . $menu->term_id . '"'
					. selected( $instance['nav_menu'], $menu->term_id, false )
					. '>'. $menu->name . '</option>';
			}
		?>
			</select>
		</p>
<?php
	}
}