<?php

class AA_Archives_Widget extends WP_Widget_Archives {

	function __construct() {
		$widget_ops = array('classname' => 'widget_archive', 'description' => __( 'Archivio mensile di articoli del tuo sito. | Amministrazione Accessibile') );
		WP_Widget::__construct('archives', 'AA > Archivi', $widget_ops);
	}

	function widget( $args, $instance ) {
		extract($args);
		$c = ! empty( $instance['count'] ) ? '1' : '0';
		$title = apply_filters('widget_title', empty($instance['title']) ? __('Archives') : $instance['title'], $instance, $this->id_base);
		$opts = array(
			'type'            => 'monthly',
			'show_post_count' => $c,
			'format'          => 'custom',
			'before'          => '<li class="list-group-item">',
			'after'           => '</li>',
			'echo'            => 0
		);

		echo $before_widget;
		if ( $title )
			echo $before_title . $title . $after_title;
		?>

		<ul class="list-group">
			<?php
				$archivi = wp_get_archives(apply_filters('widget_archives_args', $opts));
				echo preg_replace('/<\/a>(&nbsp;)*\s*\((\d+)\)\s*<\/li>/i', ' <span class="badge pull-right">$2</span></a></li>', $archivi);
			?>
		</ul>

		<?php
		echo $after_widget;
	}

	function update( $new_instance, $old_instance ) {
		$instance = $old_instance;
		$new_instance = wp_parse_args( (array) $new_instance, array( 'title' => '', 'count' => 0) );
		$instance['title'] = strip_tags($new_instance['title']);
		$instance['count'] = $new_instance['count'] ? 1 : 0;

		return $instance;
	}

	function form( $instance ) {
		$instance = wp_parse_args( (array) $instance, array( 'title' => '', 'count' => 0) );
		$title = strip_tags($instance['title']);
		$count = $instance['count'] ? 'checked="checked"' : '';
		?>

		<p><label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('Title:'); ?></label> <input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo esc_attr($title); ?>" /></p>
		<p><input class="checkbox" type="checkbox" <?php echo $count; ?> id="<?php echo $this->get_field_id('count'); ?>" name="<?php echo $this->get_field_name('count'); ?>" /> <label for="<?php echo $this->get_field_id('count'); ?>"><?php _e('Show post counts'); ?></label></p>

		<?php
	}

}