<?php

if ( shortcode_exists( 'Albo' ) && get_aa_theme_option('albo') ) {
	remove_shortcode( 'Albo' );
	add_shortcode('Albo', 'aa_albo');
}

function aa_albo($atts) {
	$atts = shortcode_atts(
		array(
			'Stato'     => '1',
			'Per_Page'  => '20',
			'Cat'       => 'All',
			'Filtri'    => 'si',
			'MinFiltri' => 'si'
		),
		$atts, 'Albo'
	);

	$r =& $_REQUEST;
	$action = isset($r['action']) ? $r['action'] : '';
	switch ($action) {
		case 'visatto':
			Albo_aa::VisualizzaAtto($r['id']);
			break;
		case 'addstatall':
			ap_insert_log(6, 5, $_GET['id'], 'Download', $_GET['idAtto']);
			break;
		default:
			if (isset($r['filtra']))
				$return = Albo_aa::Lista_Atti($atts, $r['categoria'], $r['anno'], $r['oggetto'], $r['DataInizio'], $r['DataFine']);
			else {
				if(isset($r['annullafiltro']))
					unset($r['categoria'], $r['anno'], $r['oggetto'], $r['DataInizio'], $r['DataFine']);
				$return = Albo_aa::Lista_Atti($atts);
			}
			return $return;
	}
}

class Albo_aa {

	static function Lista_Atti ( $Parametri, $Categoria = 0, $Anno = 0, $Oggetto = '', $Dadata = 0, $Adata = 0 ) {
		// return var_export($Parametri, true);
		$titoli     = array('Tutti gli Atti', 'Atti in corso di Validità', 'Atti Scaduti', 'Atti da Pubblicare');
		$TitoloAtti = isset($Parametri['stato']) ? $titoli[$Parametri['stato']] : '';

		$cat = 0;
		if (isset($Parametri['cat'])){
			$Categoria    = $Parametri['cat'];
			$DesCategoria = ap_get_categoria($Categoria);
			$TitoloAtti  .= " Categoria " . $DesCategoria[0]->Nome;
			$cat          = 1;
		} 

		$N_A_pp = isset($Parametri['per_page']) ? $Parametri['per_page'] : 100;
		$Da     = isset($_REQUEST['Pag']) ? ($_REQUEST['Pag']-1) * $N_A_pp : 0;
		$A      = $N_A_pp;

		$TotAtti         = ap_get_all_atti($Parametri['stato'], $Anno, $Categoria, $Oggetto, $Dadata, $Adata, '', 0, 0, true);
		$lista           = ap_get_all_atti($Parametri['stato'], $Anno, $Categoria, $Oggetto, $Dadata, $Adata, 'Anno DESC, Numero DESC', $Da, $A); 
		$titEnte         = get_option('opt_AP_LivelloTitoloEnte', 'h2');
		$titPagina       = get_option('opt_AP_LivelloTitoloPagina', 'h3');
		$coloreAnnullati = get_option('opt_AP_ColoreAnnullati');
		$colorePari      = get_option('opt_AP_ColorePari');
		$coloreDispari   = get_option('opt_AP_ColoreDispari');

		$titoloEnte  = get_option('opt_AP_VisualizzaEnte')=='si' ? '<'.$titEnte.'><span class="titoloEnte">'.stripslashes(get_option('opt_AP_Ente')).'</span></'.$titEnte.'>' : '';
		
		$ricerca     = self::VisualizzaRicerca($Parametri['stato'], $cat, $Parametri['minfiltri']);
		
		$paginazione = self::PaginazioneAlbo($TotAtti, $N_A_pp);
		
		list($righeAtti, $CeAnnullato) = self::TabellaAttiAlbo($lista);
		$CeAnnullato = $CeAnnullato ? '<p class="bg-danger">Le righe evidenziate con questo sfondo indicano Atti Annullati</p>' : '';

		return <<<out

		<div id="alboRicerca">
			<a name="dati"></a>
			{$titoloEnte}
			<{$titPagina}><span class="titoloPagina">{$TitoloAtti}</span></{$titPagina}>
			<h4>Filtri</h4>
			{$ricerca}
			<h4>Risultati: N° {$TotAtti} Atti</h4>
			<div class="table-responsive">
				<table summary="atti validi per riferimento, oggetto e categoria" caption="Atti" class="table table-striped"> 
					<thead>
						<tr>
							<th>Prog.</th>
							<th>Ente</th>
							<th>Rif.</th>
							<th>Oggetto</th>
							<th>Validità</th>
							<th>Categoria</th>
						</tr>
					</thead>
					<tbody>
						{$righeAtti}
					</tbody>
				</table>
			</div>

			{$paginazione}
		</div>

out;
	}

	static function VisualizzaRicerca ( $Stato = 1, $cat = 0, $StatoFinestra = 'si' ) {
		$anni      = ap_get_dropdown_anni_atti('anno', 'anno', 'form-control', '', isset($_REQUEST['anno'])?$_REQUEST['anno']:'', $Stato); 
		$categorie = ap_get_dropdown_ricerca_categorie('categoria', 'categoria', 'form-control', '', isset($_REQUEST['categoria'])?$_REQUEST['categoria']:'', $Stato); 
		ap_Bonifica_Url();
		$sep       = strpos($_SERVER['REQUEST_URI'],"?")>0 ? '&amp;' : '?';
		$titFiltri = get_option('opt_AP_LivelloTitoloFiltri', 'h3');
		$url       = $_SERVER['REQUEST_URI'];
		$pageID    = strpos($_SERVER['REQUEST_URI'],'page_id')>0 ? '<input type="hidden" name="page_id" value="'.ap_Estrai_PageID_Url().'" />' : '';
		$oggetto    = isset($_REQUEST['oggetto']) ? $_REQUEST['oggetto'] : '';
		$DataInizio = isset($_REQUEST['DataInizio']) ? $_REQUEST['DataInizio'] : '';
		$DataFine   = isset($_REQUEST['DataFine']) ? $_REQUEST['DataFine'] : '';

		return <<<ricerca
		<form method="post" action="$url" class="form-horizontal well">
			{$pageID}
			<div class="form-group">
				<label for="categoria" class="col-sm-2 control-label">Categoria</label>
				<div class="col-sm-10">
					{$categorie}
				</div>
			</div>
			<div class="form-group">
				<label for="anno" class="col-sm-2 control-label">Anno</label>
				<div class="col-sm-10">
					{$anni}
				</div>
			</div>
			<div class="form-group">
				<label for="oggetto" class="col-sm-2 control-label">Oggetto</label>
				<div class="col-sm-10">
					<input class="form-control" type="text" value="{$oggetto}" name="oggetto" maxlength="150" />
				</div>
			</div>
			<div class="form-group">
				<label for="DataInizio" class="col-sm-2 control-label">da Data</label>
				<div class="col-sm-10">
					<input class="form-control" type="text" value="{$DataInizio}" name="DataInizio" />
				</div>
			</div>
			<div class="form-group">
				<label for="DataFine" class="col-sm-2 control-label">a Data</label>
				<div class="col-sm-10">
					<input class="form-control" type="text" value="{$DataFine}" name="DataFine" />
				</div>
			</div>
			<input type="submit" name="filtra" class="btn btn-primary" value="Filtra" />
			<input type="submit" name="annullafiltro" class="btn btn-default" value="Annulla Filtro" />
		</form>
ricerca;
	}

	static function PaginazioneAlbo ( $TotAtti, $N_A_pp ) {
		if ($TotAtti>$N_A_pp) {
			$Para='';
			foreach ($_REQUEST as $k => $v)
				if ($k!="Pag" and $k!="vf")
					$Para .= $Para=='' ? "$k=$v" : "&amp;$k=$v";
			$Para = $Para=='' ? '?Pag=' : "?{$Para}&amp;Pag=";
			$Npag = (int)($TotAtti/$N_A_pp);
			if ($TotAtti%$N_A_pp>0)
				$Npag++;
			$Pagcur   = isset($_REQUEST['Pag']) ? $_REQUEST['Pag'] : 1;
			$PagPre   = $Pagcur>1 ? $Pagcur-1 : 1;
			$PagSuc   = $Pagcur<=$Npag ? $Pagcur+1 : $Npag;
			$is_first = $Pagcur==1 ? 'class="disabled"' : '';
			$is_last  = $Pagcur==$Npag ? 'class="disabled"' : '';
			return "
				<div id='alboPaginazione'>
					<ul class='pagination'>
						<li {$is_first}><a href='{Para}1'>&laquo;</a></li>
						<li {$is_first}><a href='{$Para}{$PagPre}'>&lsaquo;</a></li>
						<li class='active'><a href='#'>{$Pagcur} di {$Npag}</a></li>
						<li {$is_last}><a href='{$Para}{$PagSuc}'>&rsaquo;</a></li>
						<li {$is_last}><a href='{$Para}{$Npag}'>&raquo;</a></li>
					</ul>
				</div>
			";
		}
		return '';
	}

	static function TabellaAttiAlbo ( $lista ) {
		$CeAnnullato=false;
		$output = '';
		if ($lista) {
			foreach ($lista as $riga) {
				$categoria  = ap_get_categoria($riga->IdCategoria);
				$cat        = $categoria[0]->Nome;
				$NumeroAtto = ap_get_num_anno($riga->IdAtto);
				$classe     = '';
				if($riga->DataAnnullamento!='0000-00-00'){
					$classe      = 'class="danger"';
					$CeAnnullato = true;
				}
				$sep        = strpos(get_permalink(),"?")>0 ? '&amp;' : '?';
				$nomeEnte   = ap_get_ente($riga->Ente)->Nome;
				$permalink  = get_permalink();
				$dataInizio = ap_VisualizzaData($riga->DataInizio);
				$dataFine   = ap_VisualizzaData($riga->DataFine);
				$output    .= "
					<tr>
						<td $classe> $NumeroAtto/{$riga->Anno} </td>
						<td $classe> $nomeEnte </td>
						<td $classe> {$riga->Riferimento} </td>
						<td $classe>
							<a href='{$permalink}{$sep}action=visatto&amp;id={$riga->IdAtto}'>{$riga->Oggetto}</a>  
						</td>
						<td $classe> $dataInizio <br /> $dataFine </td>
						<td $classe> $cat </td>
					</tr>
				";
			}
		} else
			$output .= '<tr><td colspan="6">Nessun Atto Codificato</td></tr>';
		return array($output, $CeAnnullato);
	}

	static function VisualizzaAtto ( $id ) {
		$risultato          = current(ap_get_atto($id));
		$risultatocategoria = current(ap_get_categoria($risultato->IdCategoria));
		$allegati           = ap_get_all_allegati_atto($id);
		$responsabile       = current(ap_get_responsabile($risultato->RespProc));
		ap_insert_log(5, 5, $id, 'Visualizzazione');
		$coloreAnnullati    = get_option('opt_AP_ColoreAnnullati');
		$Annullato          = $risultato->DataAnnullamento!='0000-00-00' ? "<p class='danger'>Atto Annullato dal Responsabile del Procedimento<br /><br />Motivo: <span>{$risultato->MotivoAnnullamento}</span></p>" : '';
		$url = get_permalink();
		$dati = array(
			'ente'      => ap_get_ente($risultato->Ente)->Nome,
			'numero'    => $risultato->Numero.'/'.$risultato->Anno,
			'data'      => ap_VisualizzaData($risultato->Data),
			'codice'    => stripslashes($risultato->Riferimento),
			'oggetto'   => stripslashes($risultato->Oggetto),
			'inizio'    => ap_VisualizzaData($risultato->DataInizio),
			'fine'      => ap_VisualizzaData($risultato->DataFine),
			'note'      => stripslashes($risultato->Informazioni),
			'categoria' => stripslashes($risultatocategoria->Nome),
			'persona'   => $responsabile->Cognome.' '.$responsabile->Nome,
			'email'     => $responsabile->Email,
			'tel'       => $responsabile->Telefono,
			'orario'    => $responsabile->Orario,
		);
		$note_resp = $responsabile->Note ? "<dt>Note</dt><dd>{$responsabile->Note}</dd>" : '';
		$output = "
			<p><a href='{$url}' title='Torna alla lista degli atti'><i class='fa fa-arrow-left'></i> Torna alla Lista</a></p>
			<h2>Dati atto</h2>
			{$Annullato}
			<dl id='dati_atto' class='dl-atto dl-horizontal well'>
				<dt>Ente titolare dell'Atto</dt>
				<dd>{$dati['ente']}</dd>
				<dt>Numero Albo</dt>
				<dd>{$dati['numero']}</dd>
				<dt>Data</dt>
				<dd>{$dati['data']}</dd>
				<dt>Codice di Riferimento</dt>
				<dd>{$dati['codice']}</dd>
				<dt>Oggetto</dt>
				<dd>{$dati['oggetto']}</dd>
				<dt>Data inizio Pubblicazione</dt>
				<dd>{$dati['inizio']}</dd>
				<dt>Data fine Pubblicazione</dt>
				<dd>{$dati['fine']}</dd>
				<dt>Note</dt>
				<dd>{$dati['note']}</dd>
				<dt>Categoria</dt>
				<dd>{$dati['categoria']}</dd>
			</dl>
		";
		if($responsabile)
			$output .= "
				<h3>Responsabile</h3>
				<dl class='dl-atto dl-horizontal well'>
						<dt>Persona</dt>
						<dd>{$dati['persona']}</dd>
						<dt>email</dt>
						<dd><a href='mailto:{$dati['email']}'>{$dati['email']}</a></dd>
						<dt>Telefono</dt>
						<dd>{$dati['tel']}</dd>
						<dt>Orario ricevimento</dt>
						<dd>{$dati['orario']}</dd>
						{$note_resp}
				</dl>
			";
		if(count((array)$allegati)) {
			$righe = '';
			foreach ($allegati as $a)
				$righe .= self::rigaAllegato($a, $id);
			$output .= "
				<h3>Allegati</h3>
				<dl class='dl-atto dl-horizontal well'>
					{$righe}
				</dl>
			";
		}
		echo "<div id='alboAtto'>{$output}</div>";
	}

	static function rigaAllegato ($allegato, $idAtto) {
	 	switch (ap_ExtensionType($allegato->Allegato)){
			case 'pdf':
				$Estensione = 'Pdf.png';
				$Verifica   = '';
				break;
			case 'p7m':
				$Estensione = 'firmato.png';
				$Verifica   = '<br /><a href="http://postecert.poste.it/verificatore/servletverificatorep7m?tipoOp=10" onclick="window.open(this.href);return false;">Verifica firma con servizio fornito da poste.it</a>';
				break;
		}
		$sep = strpos(get_permalink(),"?")>0 ? '&amp;' : '?';
		$dati = array(
			'url'  => ap_DaPath_a_URL($allegato->Allegato),
			'rel'  => get_permalink().$sep.'action=addstatall&amp;id='.$allegato->IdAllegato.'&amp;idAtto='.$idAtto,
			'file' => basename($allegato->Allegato),
			'size' => ap_Formato_Dimensione_File(filesize($allegato->Allegato))
		);
		$albo_url = Albo_URL;
		return "
			<dt>
			    <img src='{$albo_url}img/{$Estensione}' alt='Icona Visualizza Atto' />
			</dt>
			<dd>
					{$allegato->TitoloAllegato} <br />
					<a href='{$dati['url']}' rel='{$dati['rel']}'>{$dati['file']}</a>
					<span class='badge'>{$dati['size']}</badge>
					{$Verifica}
			</dd>
		";
	}

}
