<?php

if ( shortcode_exists('avcp') && get_aa_theme_option('avcp') ) {
	remove_shortcode('avcp');
	add_shortcode('avcp', 'aa_avcp');
	add_action( 'wp_enqueue_scripts', array('AA_avcp', 'css'));
}

function aa_avcp ( $atts ) {
	extract(shortcode_atts(
		array( 'anno' => 'all' ),
		$atts, 'avcp'
	));

	AA_avcp::js();
	
	$args  = array( 'post_type' => 'avcp', 'orderby' => 'date', 'order' => 'DESC', 'posts_per_page' => -1  );
	if(is_numeric($anno))
		$args['annirif'] = $anno;
	
	query_posts( $args );

	AA_avcp::tabella(is_numeric($anno) ? "Anno $anno" : 'Tutti gli Anni');

	wp_reset_query();
}

class AA_avcp {

	static function css () {
		wp_enqueue_style('datatables-bootstrap', '//cdn.datatables.net/plug-ins/505bef35b56/integration/bootstrap/3/dataTables.bootstrap.css');
		wp_enqueue_style('datatables-responsive', get_template_directory_uri().'/js/datatables-responsive/files/1.10/css/datatables.responsive.css');
		// wp_enqueue_style('tabletools', '//cdn.datatables.net/tabletools/2.2.1/css/dataTables.tableTools.css');
	}

	static function js () {
		wp_enqueue_script( 'datatables', '//cdn.datatables.net/1.10.0/js/jquery.dataTables.min.js', array('jquery'), '1.10.0', true );
		wp_enqueue_script( 'tabletools', '//cdn.datatables.net/tabletools/2.2.1/js/dataTables.tableTools.min.js', array('datatables'), null, true );
		wp_enqueue_script( 'datatables-bootstrap', '//cdn.datatables.net/plug-ins/505bef35b56/integration/bootstrap/3/dataTables.bootstrap.js', array('datatables'), null, true );
		wp_enqueue_script( 'datatables-responsive', get_template_directory_uri().'/js/datatables-responsive/files/1.10/js/datatables.responsive.js', array('datatables'), null, true );
		add_action( 'wp_print_footer_scripts', array('AA_avcp', 'init_datatable') );
		// wp_enqueue_script( 'aa-datatables', get_template_directory_uri().'/js/datatables.js', array('datatables'), null, true );
	} // css_js

	static function tabella ($title) {
		$mesi = array(1=>'gennaio', 'febbraio', 'marzo', 'aprile', 'maggio', 'giugno', 'luglio', 'agosto', 'settembre', 'ottobre', 'novembre', 'dicembre');
	?>

		<h3>Elenco Bandi e appalti - <?php echo $title; ?></h3>
		<table class="table table-striped table-bordered" id="avcp_tbl">
			<thead>
				<tr>
					<th data-class="expand">Oggetto</th>
					<th data-hide="phone,tablet_v,tablet_h,desktop,large">C.I.G.</th>
					<th data-hide="phone,desktop">Importo agg.</th>
					<th data-hide="phone,tablet_v,tablet_h,desktop,large">Importo liq.</th>
					<th>Data di inizio</th>
					<th data-hide="phone,tablet_v">Data di fine</th>
					<th data-hide="phone,tablet_v,tablet_h,desktop,large">Procedura di scelta</th>
					<th data-hide="phone,tablet_v,tablet_h,desktop,large">Partecipanti</th>
					<th data-hide="phone,tablet_v,tablet_h,desktop,large">Aggiudicatari</th>
				</tr>
			</thead>
			<tbody>
			<?php if ( have_posts() ) : while ( have_posts() ) : the_post(); global $post; ?>
				<?php				
				$avcp_cig                    = get_post_meta($post->ID, 'avcp_cig', true);
				$avcp_importo_aggiudicazione = get_post_meta($post->ID, 'avcp_aggiudicazione', true);
				list($giorno,$mese,$anno)    = explode(' ', date('j n Y', strtotime(get_post_meta(get_the_ID(), 'avcp_data_inizio', true))));
				list($giorno1,$mese1,$anno1) = explode(' ', date('j n Y', strtotime(get_post_meta(get_the_ID(), 'avcp_data_fine', true))));
				$terms                       = get_the_terms( $post->ID, 'ditte' );
				$dittepartecipanti           = get_the_terms( $post->ID, 'ditte' );
				$cats                        = get_post_meta($post->ID, 'avcp_aggiudicatari', true);
				?>
				<tr>
					<td><a href="<?php the_permalink() ?>" title="<?php the_title_attribute(); ?>"><?php the_title(); ?></a></td>
					<td><?php echo $avcp_cig; ?></td>
					<td><?php echo '€ ' . $avcp_importo_aggiudicazione; ?></td>
					<td><?php echo '€ ' . get_post_meta(get_the_ID(), 'avcp_somme_liquidate', true); ?></td>
					<td><?php echo "$giorno.$mese.$anno"; ?></td>
					<td><?php echo "$giorno1.$mese1.$anno1"; ?></td>
					<td><?php echo get_post_meta(get_the_ID(), 'avcp_contraente', true); ?></td>
					<td><?php AA_avcp::ditte($terms); ?></td>
					<td><?php AA_avcp::partecipanti($dittepartecipanti, $cats); ?></td>
				</tr>
			<?php endwhile; else: ?>
				<tr><td><p>Nessuna gara trovata.</p></td></tr>
			<?php endif; ?>
			</tbody>
		</table>

	<?php
	} // tabella

	static function ditte ($terms) {
		if ($terms)
			foreach($terms as $term) { 
				$get_term    = get_term_by('name', $term->name, 'ditte');
				$t_id        = $get_term->term_id;
				$term_meta   = get_option("taxonomy_$t_id");
				$term_return = esc_attr( $term_meta['avcp_codice_fiscale'] );
				$stato_var   = get_tax_meta($t_id,'avcp_is_ditta_estera');
				$is_estera   = empty($stato_var) ? '<acronym title="Identificativo Fiscale Italiano">IT</acronym>' : '<acronym title="Identificativo Fiscale Estero">EE</acronym>';
				$get_avcp_dis_archivioditte = get_option('avcp_dis_archivioditte');
				echo $get_avcp_dis_archivioditte == '1' ? $term->name : '<a href="' . get_term_link( $t_id, 'ditte' ) . '" title="' . $term->name . '">' . $term->name . '</a>';
				echo ' (' . $term_return . ' <strong>' . $is_estera . '</strong>)';
			}
	} // ditte

	static function partecipanti ($dittepartecipanti, $cats) {
		if( is_array($dittepartecipanti) )
			foreach ($dittepartecipanti as $term) {
				$cterm       = get_term_by('name',$term->name,'ditte');
				$cat_id      = $cterm->term_id; //Prende l'id del termine
				$term_meta   = get_option( "taxonomy_$cat_id" );
				$term_return = esc_attr( $term_meta['avcp_codice_fiscale'] );
				$checked     = in_array($cat_id,(array)$cats) ? ' checked="checked"': '';
				$stato_var   = get_tax_meta($cat_id,'avcp_is_ditta_estera');
				$is_estera   = empty($stato_var) ? '<acronym title="Identificativo Fiscale Italiano">IT</acronym>' : '<acronym title="Identificativo Fiscale Estero">EE</acronym>';
				if ($checked) {
					$get_avcp_dis_archivioditte = get_option('avcp_dis_archivioditte');
					if ($get_avcp_dis_archivioditte != '1') {
						$ditte = get_term_link( $cterm->term_id, 'ditte' );
						echo "
							<a href='{$ditte}' title='{$term->name}'>
								{$term->name}
							</a>
						";
					} else echo $term->name;					
					echo ' (' . $term_return . ' <strong>' . $is_estera . '</strong>)';
				}
			}
	} // partecipanti

	static function init_datatable() {
		$nomesito = sanitize_title( get_bloginfo('name') );
		$tabledom = (get_option('avcp_export')=='0' ? 'T' : '') . '<"clearfix"><lfr><"clearfix">t<"clearfix"><"clearfix"ip>';
		?>

		<script type="text/javascript">
		'use strict';

		(function($){

			if($('#avcp_tbl').length) {
				var responsiveHelper = undefined;
				var breakpointDefinition = {
					large    : 9999,
					desktop  : 1200,
					tablet_h : 992,
					tablet_v : 768,
					phone    : 480
				};
				var tableElement = $('#avcp_tbl');

				var table = tableElement.dataTable({
					autoWidth : false,
					preDrawCallback: function () {
						// Initialize the responsive datatables helper once.
						if (!responsiveHelper) {
						responsiveHelper = new ResponsiveDatatablesHelper(tableElement, breakpointDefinition);
						}
					},
					rowCallback    : function (nRow) {
						responsiveHelper.createExpandIcon(nRow);
					},
					drawCallback   : function (oSettings) {
						responsiveHelper.respond();
					},

					"sDom": '<?php echo $tabledom; ?>',

					"oLanguage": {
						"sProcessing":   "Caricamento dati avcp...",
						"sLengthMenu":   "_MENU_ voci",
						"sZeroRecords":  "Nessun risultato trovato.",
						"sInfo":         "_START_-_END_ di _TOTAL_ voci",
						"sInfoEmpty":    "0 voci",
						"sInfoFiltered": "(filtrati da _MAX_ voci totali)",
						"sInfoPostFix":  "",
						"sSearch":       "Cerca: ",
						"sFirst":    "Inizio",
						"sPrevious": "Precedente",
						"sNext":     "Successivo",
						"sLast":     "Fine",
						"oPaginate": {
							"sFirst":    "«",
							"sPrevious": "&lt;",
							"sNext":     "&gt;",
							"sLast":     "»",
						},
					},

					"oTableTools": {
						"sSwfPath": "//cdn.datatables.net/tabletools/2.2.1/swf/copy_csv_xls_pdf.swf",
						"aButtons": [
							{
								"sExtends":    "copy",
								"sButtonText": "Copia",
								"mColumns": [1, 2, 3, 4, 5, 6, 7, 8, 9],
								/*"sButtonClass": "btn btn-default"*/
							},
							{
								"sExtends":    "print",
								"sButtonText": "Stampa",
								"sInfo": "<h2>Modalità Stampa</h2>La tabella è pronta! Usa la funzione di stampa del tuo browser per completare",
								"mColumns": [1, 2, 3, 4, 5, 6, 7, 8, 9],
								/*"sButtonClass": "btn btn-default"*/
							},
							{
								"sExtends":    "collection",
								"sButtonText": "Esporta",
								"aButtons":    [
									{
										"sExtends": "csv",
										"sButtonText": "CSV",
										"sFileName": "<?php echo $nomesito; ?>_gare.csv",
										"mColumns": [1, 2, 3, 4, 5, 6, 7, 8, 9],
										/*"sButtonClass": "btn btn-default"*/
									},
									{
										"sExtends": "xls",
										"sButtonText": "EXCEL",
										"sFileName": "<?php echo $nomesito; ?>_gare.xls",
										"mColumns": [1, 2, 3, 4, 5, 6, 7, 8, 9],
										/*"sButtonClass": "btn btn-default"*/
									},
									{
										"sExtends": "pdf",
										"sButtonText": "PDF",
										"sPdfOrientation": "landscape",
										"sPdfMessage": "<?php echo get_bloginfo('name'); ?> - Bandi di Gara",
										"sFileName": "<?php echo $nomesito; ?>_gare.pdf",
										"mColumns": [1, 2, 3, 4, 5, 6, 7, 8, 9],
										/*"sButtonClass": "btn btn-default"*/
									}
								],
								/*"sButtonClass": "btn btn-default"*/
							}
						]
					}

				});

			}

		})(jQuery);
		</script>

		<?php
	} // init_datatable

}