<?php

/**
 * Lista dei tasti di accesso rapido dei menù
 */
function aa_accesskeys_shortcode() {
	$out = '<ul>';
	if ( ( $locations = get_nav_menu_locations() ) ) {
		if(isset( $locations['principale'] )) {
			$menu_obj = wp_get_nav_menu_object( $locations['principale'] );
			$menu = wp_get_nav_menu_items($menu_obj->term_id);
			if(count((array)$menu))
				foreach ($menu as $i => $item)
					$out .= '<li>[Shift+Alt+' . ($i+1) . "] {$item->title}</li>";
		}
		if(isset( $locations['superiore'] )) {
			$menu_obj = wp_get_nav_menu_object( $locations['superiore'] );
			$menu = wp_get_nav_menu_items($menu_obj->term_id);
			if(count((array)$menu))
				foreach ($menu as $i => $item)
					$out .= '<li>[Shift+Alt+' . chr(65+$i) . "] {$item->title}</li>";
		}
	}
	$out .= '</ul>';
	return $out;
}
add_shortcode( 'accesso-rapido', 'aa_accesskeys_shortcode' );

/**
 * Sitemap
 */
function aa_sitemap_shortcode() {
	ob_start();
	?>

	<h2>Pagine</h2>
	<ul><?php echo wp_list_pages('title_li='); ?></ul>

	<h2>Categorie</h2>
	<ul>
		<?php
		$cats = get_categories();
		foreach ($cats as $cat) {
			$url   = get_category_link( $cat->term_id );
			$title = sprintf( 'Visualizza gli articoli di &ldquo;%s&rdquo;', $cat->name );
			echo "<li><a href='{$url}' title='{$title}'>{$cat->cat_name}</a></li>";
		}
		?>
	</ul>

	<?php /*
	foreach( get_post_types( array('public' => true) ) as $post_type ) {
		if ( in_array( $post_type, array('post','page','attachment') ) )
			continue;

		$pt = get_post_type_object( $post_type );

		echo '<h2>'.$pt->labels->name.'</h2>';
		echo '<ul>';

		query_posts('post_type='.$post_type.'&posts_per_page=-1');
		while( have_posts() ) {
			the_post();
			echo '<li><a href="'.get_permalink().'">'.get_the_title().'</a></li>';
		}

		echo '</ul>';
	} */

	return str_replace('list-group-item', '', ob_get_clean());
}
add_shortcode( 'sitemap', 'aa_sitemap_shortcode' );
